import { CreateFeatureParams, ListFeatureParams, UpdateFeatureParams, ListResponse, Warrant, WarrantObject } from "../types";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
export default class Feature implements WarrantObject {
    featureId: string;
    meta?: {
        [key: string]: any;
    };
    constructor(featureId: string, meta: {
        [key: string]: any;
    });
    static create(params?: CreateFeatureParams, options?: WarrantRequestOptions): Promise<Feature>;
    static get(featureId: string, options?: WarrantRequestOptions): Promise<Feature>;
    static update(featureId: string, params: UpdateFeatureParams, options?: WarrantRequestOptions): Promise<Feature>;
    static delete(featureId: string, options?: WarrantRequestOptions): Promise<string>;
    static listFeatures(listParams?: ListFeatureParams, options?: WarrantRequestOptions): Promise<ListResponse<Feature>>;
    static listFeaturesForPricingTier(pricingTierId: string, listParams?: ListFeatureParams, options?: WarrantRequestOptions): Promise<ListResponse<Feature>>;
    static assignFeatureToPricingTier(pricingTierId: string, featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removeFeatureFromPricingTier(pricingTierId: string, featureId: string, options?: WarrantRequestOptions): Promise<string>;
    static listFeaturesForTenant(tenantId: string, listOptions?: ListFeatureParams, options?: WarrantRequestOptions): Promise<ListResponse<Feature>>;
    static assignFeatureToTenant(tenantId: string, featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removeFeatureFromTenant(tenantId: string, featureId: string, options?: WarrantRequestOptions): Promise<string>;
    static listFeaturesForUser(userId: string, listOptions?: ListFeatureParams, options?: WarrantRequestOptions): Promise<ListResponse<Feature>>;
    static assignFeatureToUser(userId: string, featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removeFeatureFromUser(userId: string, featureId: string, options?: WarrantRequestOptions): Promise<string>;
    getObjectType(): string;
    getObjectId(): string;
}
