import { ListParams } from "./List";
import { WarrantObject, WarrantObjectLiteral } from "./Object";
export interface ListWarrantParams extends ListParams {
    objectType?: string;
    objectId?: string;
    relation?: string;
    subjectType?: string;
    subjectId?: string;
}
export interface PolicyContext {
    [key: string]: any;
}
export interface Subject {
    objectType: string;
    objectId: string;
    relation?: string;
}
export declare function isSubject(object: any): object is Subject;
export interface Warrant {
    objectType: string;
    objectId: string;
    relation: string;
    subject: Subject;
    policy?: string;
    warrantToken?: string;
}
export interface WarrantParams {
    object: WarrantObject | WarrantObjectLiteral;
    relation: string;
    subject: WarrantObject | Subject;
    policy?: string;
}
